#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#ifdef	HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

#ifdef HAVE_LIBCOST
#include <cost.h>

double dataCost = 0;
int _lc_cost_initialized = 0;
char **_lc_cost_cls = NULL;
#endif

#ifdef	HAVE_TIME_H
#include <time.h>
#endif

#ifdef	HAVE_SYS_TIME_H
#include <sys/time.h>
#endif

#ifdef	HAVE_GD_H
#include <gd.h>
#endif

#ifdef	HAVE_GDFONTS_H
#include <gdfonts.h>
#endif

#ifdef	HAVE_GDFONTS_H
#include <gdfontt.h>
#endif

#include <strfunc.h>

#include "desire.h"
#include "ddraw.h"


struct custom_line lines[] = {
	/* All */
  { 0x606060, 0xf0f0f0, FIELD_SRC, 0xffffffff, FIELD_U1, -1, -1, NULL, 0 },
	/* In */
  { 0x3030ff, -1, FIELD_IN, 0xffffffff, FIELD_U1, -1, -1, NULL, 0 },
	/* Out */
  { 0xff3030, -1, FIELD_OUT, 0xffffffff, FIELD_U1, -1, -1, NULL, 0 },
};

void preFilter(ctb_session *, ctb_data *, int, struct desire_image_options *);

char buf[1024];

int
main(int ac, char **av) {
	struct desire_image_options *io;
	ctb_dss *dss = NULL;
	gdImagePtr im;
	ctb_session *ctbs = NULL;
	float fl;

	printf("Expires: %s\n", timetostr(time(NULL)-300,
		TFMT_RFC822 | TFMT_OLD822GMT));
#ifdef	HAVE_GDIMAGEPNG
	printf("Content-type: image/png\n\n");
#else
	printf("Content-type: image/gif\n\n");
#endif
	fflush(stdout);

	io=fill_desire_image_options(0);
	io->legend_factor = 1024;
	io->vertical_legend = strdup("KBytes per second");

	if(!io->comments)
		io->comments = sinit();

	if(io->service && (ctbs=ctb_open(NULL, io->service, io->file))) {
		dss=ctb_get_dss(ctbs, &io->range);
	};

#ifdef	HAVE_LIBCOST
if(io->costtype && !lc_init(NULL) && dss) {

	_lc_cost_initialized = 1;

	if(io->costclass)
		_lc_cost_cls=charize(io->costclass);

	sadd(io->comments, "Service cost");
};
#endif

	io->optBlockPreFilter = preFilter;

	im=ddraw_dss(ctbs, dss, lines,
		sizeof(lines)/sizeof(struct custom_line), io);

    sprintf(buf, "Display time: %ld.%03ld",
        io->elapsed.tv_sec, io->elapsed.tv_usec/1000);
    gdImageString(im, gdFontTiny, io->image_width - 5 * (strlen(buf) + 2) , io->
image_height - 24 , buf, 0);

	sprintf(buf, "A: %quk", lines[0].all >> 10);
		gdImageString(im, gdFontSmall, 6, 95, buf, lines[0].foreColor);
	fl = lines[0].meaningful_points
		?(float)(lines[0].all >> 10)/lines[0].meaningful_points/io->inpixel:0;
	sprintf(buf, "   %0.2fk/s", fl);
		gdImageString(im, gdFontSmall, 6, 105, buf, lines[0].foreColor);

	sprintf(buf, "I: %quk", lines[1].all >> 10);
		gdImageString(im, gdFontSmall, 6, 115, buf, lines[1].foreColor);
	fl = lines[1].meaningful_points
		?(float)(lines[1].all >> 10)/lines[1].meaningful_points/io->inpixel:0;
	sprintf(buf, "   %0.2fk/s", fl);
		gdImageString(im, gdFontSmall, 6, 125, buf, lines[1].foreColor);

	sprintf(buf, "O: %quk", lines[2].all >> 10);
		gdImageString(im, gdFontSmall, 6, 135, buf, lines[2].foreColor);
	fl = lines[2].meaningful_points
		?(float)(lines[2].all >> 10)/lines[2].meaningful_points/io->inpixel:0;
	sprintf(buf, "   %0.2fk/s", fl);
		gdImageString(im, gdFontSmall, 6, 145, buf, lines[2].foreColor);

	if(isatty(1))
		fprintf(stderr, "[Image will be displayed here]\n");
	else {
#ifdef	HAVE_GDIMAGEPNG
		gdImagePng(im, stdout);
#else
		gdImageGif(im, stdout);
#endif
	}

	return 0;
};


void preFilter(ctb_session *ctbs, ctb_data *data, int dataCount, struct desire_image_options *io) {
	int dc;
	ctb_data *dt;
	int EntrySize = ctb_entry_size(ctbs);

#ifdef	HAVE_LIBCOST
	if(!data) {
		if((dc = scfind(io->comments, "Servise cost")) != -1) {
			sdel(io->comments, dc);
			sprintf(buf, "Service cost (incoming): %.2f$.", dataCost);
			sins(io->comments, buf, dc);
		}
	}
#endif

	for(dc = dataCount, dt = data; dc; ((char *)dt) += EntrySize, dc--)
		dt->Src = dt->In + dt->Out;

#ifdef	HAVE_LIBCOST
	if(_lc_cost_initialized)
		dataCost += lc_cost(data, dataCount, EntrySize,
			FIELD_TS, FIELD_IN, sizeof(int),
				0, io->costtype, _lc_cost_cls);
#endif


};

