/* $Id: mail_getstat.c,v 1.2 2001/04/10 13:49:38 vlm Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include <sysexits.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/stat.h>
#include <string.h>
#include <pwd.h>
#include <ctype.h>
#include <setjmp.h>
#include <signal.h>

#ifdef	HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

#ifdef	HAVE_SYS_TIME_H
#include <sys/time.h>
#endif

#ifdef	HAVE_SYS_RESOURCE_H
#include <sys/resource.h>
#endif

#include <strfunc.h>

#include "desire.h"

ctb_session *ctbs=NULL;

void usage(char *);
ctb_data *parser(char *str);

slist *localdomains = NULL;

int
main(int ac, char **av) {
	int c;
	char *acco="email";
	char *desconf=NULL;
	char *myconf=NULL;

	while(( c = getopt(ac, av, "a:c:m:l:") ) != -1)
	switch(c) {
		case 'a':
			acco = optarg;
			break;
		case 'c':
			desconf = optarg;
			break;
		case 'l':
			if(!localdomains)
				localdomains = sinit();
			sadd(localdomains, optarg);
			break;
		case 'm':
			myconf = optarg;
			break;
		default:
			usage(*av);
	};

	ac -= optind;
	if(ac != 1)
		usage(*av);
	av += optind;

	if(myconf) {
		if( cfgread(myconf) == 0) {
			slist *sl;
			sl = cfgget2("localdomains");
			if(sl) {
				if(!localdomains)
					localdomains = sinit();
				simport(localdomains, mkarray(sl, 0));
			}
		}
	}

	if(!(ctbs=ctb_open(desconf, acco, NULL))) {
		fprintf(stderr, "Can't open DESIRE session.\n");
		exit(EX_UNAVAILABLE);
	};

	ctb_mux(ctbs, parser, 0, av, "mailstat.pos");


	ctb_close(ctbs);

	fprintf(stderr, "Process completed.\n");
//	display_stats();

	return 0;
};

