/*
 * Cool Technical Desire, general accounting and statistics API.
 *
 * Copyright (c) 2000, 2001 Lev Walkin, Alexandr Grigoryev, Vlad Skvortsov.
 *
 */

#ifndef	__DESIRE_DATA_H__
#define __DESIRE_DATA_H__

#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>


union CTB4 {
	/* i: To be accessed by whole (FL.i) */
	unsigned int	i;

	/* s: To be accessed by shorts (FL.s.s1 - first short) */
	struct _CTB_shorts {
		unsigned short s1	__attribute__ ((packed));
		unsigned short s2	__attribute__ ((packed));
	} s;

	/* c: To be accessed byte-wise
	** (FL.c.s1c1 - first byte of the first short)
	*/
	struct _CTB_bytes {
		unsigned char s1c1	__attribute__ ((packed));
		unsigned char s1c2	__attribute__ ((packed));
		unsigned char s2c1	__attribute__ ((packed));
		unsigned char s2c2	__attribute__ ((packed));
	} c;
};

/* Default data format */
typedef struct {
	time_t	TS	__attribute__ ((packed));	/* Time stamp */
	union CTB4 FL	__attribute__ ((packed));	/* Flags */
	unsigned int In __attribute__ ((packed));	/* In */
	unsigned int Out __attribute__ ((packed));	/* Out */
	unsigned int Src __attribute__ ((packed));	/* Source */
	unsigned int Dst __attribute__ ((packed));	/* Destination */
	unsigned int U1 __attribute__ ((packed));	/* User defined */
	unsigned int U2 __attribute__ ((packed));	/* User defined */
} ctb_data;

/* FIELD constants: field offsets within ctb_data structure */
#define	FIELD_TS	 0	/* TS Offset */
#define	FIELD_FL	 4	/* FL Offset */
#define	FIELD_IN	 8	/* In Offset */
#define	FIELD_OUT	12	/* Out Offset */
#define	FIELD_SRC	16	/* Src Offset */
#define	FIELD_DST	20	/* Dst Offset */
#define	FIELD_U1	24	/* U1 Offset */
#define	FIELD_U2	28	/* U2 Offset */

#endif
