/*
 * Cool Technical Desire, general accounting and statistics API.
 *
 * Copyright (c) 2000, 2001 Lev Walkin, Alexandr Grigoryev, Vlad Skvortsov.
 *
 */

#ifndef	__DESIRE_RANGE_H__
#define	__DESIRE_RANGE_H__

#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>


/* CLP constants: accounting period position */
#define	CURR  0x00
#define	LAST  0x10
#define	PREV  0x20

/* HDWMY constants: accounting period */
#define	HOUR  0x01
#define	DAY   0x02
#define	WEEK  0x03
#define	MONTH 0x04
#define	YEAR  0x05

/* Structure representing a time range */
typedef struct {
	time_t from;
	time_t to;
	int simple_def;
		/*
		** either constants:
		** 0 - use from & to fields
		** 1 - use simple_def (LP | HDWMY)
		** 2 - both simple_def & from & to are set correctly
		*/
	int	either;
} ctb_range;

#endif
